// Command code
//
#define		COMMAND_GET_VERSION			0x00
#define		COMMAND_SOFTWARE_REBOOT		0xFF
#define		COMMAND_CHECK_FINGER		0x4B
#define		COMMAND_CAPTURE_IMAGE		0x49
#define		COMMAND_PROCESS_IMAGE		0x50
#define		COMMAND_MATCH_FINGER		0x52
#define		FLAG_1_1_MATCH				0
#define		FLAG_1_N_MATCH				1
#define		COMMAND_STORE_TEMPLATE		0x41
#define		COMMAND_STORE_SAMPLE		0x53
#define		COMMAND_DOWNLOAD_RAW_IMAGE	0x44
#define		COMMAND_CONVERT_RAW_TO_WSQ		0x36		//v3.0.1
#define		COMMAND_DOWNLOAD_WSQ_IMAGE	0x0F		//v3.0.1
//command for upgrade firmware
#define		COMMAND_DOWNLOAD_FROM_FLASH	0x42
#define		COMMAND_UPLOAD_TO_RAM		0x0D
#define		COMMAND_DOWNLOAD_FROM_RAM	0x0F
#define		COMMAND_WRITE_TO_FLASH		0x10
//
#define		COMMAND_DOWNLOAD_USER_LIST	0x57
#define		COMMAND_DELETE_ALL_USER		0x45
#define		COMMAND_DELETE_1_USER		0x48
//Network setting
#define		COMMAND_NETWORK_SETTING		0x61
#define		FLAG_GET_IP_GW				0x03
#define		FLAG_SET_IP_GW				0x04
#define		FLAG_GET_MAC_PORT			0x05
#define		FLAG_SET_MAC_PORT			0x06
#define		FLAG_GET_SM					0x09	//subnet mask
#define		FLAG_SET_SM					0x0A
#define		FLAG_SAVE_SETTING			0x99
//
#define		COMMAND_CHANGE_USER_TYPE	0x47
#define		COMMAND_SECURITY_LEVEL		0x4A
#define		COMMAND_GET_SPACE			0x4F
#define		COMMAND_DOWNLOAD_TEMPLATE	0x54
#define		COMMAND_UPLOAD_TEMPLATE		0x55
//
#define		COMMAND_PERIPHERIAL_CONTROL 0x11
//

//Error code
#define		RET_OK						0x40
#define		RET_NO_IMAGE				0x41
#define		RET_BAD_QUALITY				0x42
#define		RET_TOO_LITTLE_POINTS		0x43
#define		RET_EMPTY_BASE				0x44
#define		RET_UNKNOWN_USER			0x45
#define		RET_NO_SPACE				0x46
#define		RET_BAD_ARGUMENT			0x47
#define		RET_CRC_ERROR				0x49
#define		RET_RXD_TIMEOUT				0x4A
#define		RET_USER_ID_IS_ABSENT		0x4D
#define		RET_USER_ID_IS_USED			0x4E
#define		RET_VERY_SIMILAR_SAMPLE		0x4F
#define		RET_USER_SUSPENDED			0x54
#define		RET_UNKNOWN_COMMAND			0x55
#define		RET_INVALID_STOP_BYTE		0x57
#define		RET_HARDWARE_ERROR			0x58
#define		RET_BAD_TEST_OBJECT			0x59
#define		RET_BAD_FLASH				0x5A
#define		RET_TOO_MANY_VIP			0x5B
//
#define		RET_WINSOCK_ERROR			0x30
#define		RET_CONNECT_TIMEOUT			0x31
#define		RET_FLAG_ZERO				0x32


#define		FAM_BAUDRATE_115200			5
#define		FAM_BAUDRATE_230400			6
#define		FAM_BAUDRATE_460800			7
#define		FAM_BAUDRATE_921600			8
